﻿// 
// $Id: Event.cs 3982 2010-11-02 11:13:56Z unknown $
// 
// Zen UI Toolkit Copyright (c) 2010, Paul Clancy.  All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification, are permitted provided 
// that the following conditions are met:
// 
// * 	Redistributions of source code must retain the above copyright notice, this list of 
// 	conditions and the following disclaimer.
// 
// * 	Redistributions in binary form must reproduce the above copyright notice, this list of 
// 	conditions and the following disclaimer in the documentation and/or other materials 
// 	provided with the distribution.
// 
// * 	Neither the name of AppTek nor the names of its contributors may be used to endorse 
// 	or promote products derived from this software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
// THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
// OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// 

#region

using System;
using System.Collections.Generic;
using Newtonsoft.Json;

#endregion

namespace Zen.Toolkit
{
    public class ZenEventArgs : EventArgs
    {
        public ZenEventArgs()
        {
            Response = new ZenEventResponse();
            Parameters = new Dictionary<string, object>();
        }

        public Dictionary<string, object> Parameters { get; set; }
        public ZenEventResponse Response { get; set; }
    }

    public class ZenEventBase
    {
        public string Handler { get; set; }
    }

    public class ZenServerEvent : ZenEventBase
    {
        public string OnSuccess { get; set; }
        public string OnFailure { get; set; }
        public int TimeoutMilliseconds { get; set; }
    }

    public class ZenClientEvent : ZenEventBase
    {
        public string Script { get; set; }
    }

    public class ZenEventResponse
    {
        [JsonProperty(PropertyName = "scriptPayload")]
        public string ScriptPayload { get; set; }

        [JsonProperty(PropertyName = "htmlPayload")]
        public string HtmlPayload { get; set; }

        [JsonProperty(PropertyName = "message")]
        public string Message { get; set; }

        [JsonProperty(PropertyName = "success")]
        public bool Success { get; set; }
    }
}