﻿// 
// $Id: Exceptions.cs 3982 2010-11-02 11:13:56Z unknown $
// 
// Zen UI Toolkit Copyright (c) 2010, Paul Clancy.  All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification, are permitted provided 
// that the following conditions are met:
// 
// * 	Redistributions of source code must retain the above copyright notice, this list of 
// 	conditions and the following disclaimer.
// 
// * 	Redistributions in binary form must reproduce the above copyright notice, this list of 
// 	conditions and the following disclaimer in the documentation and/or other materials 
// 	provided with the distribution.
// 
// * 	Neither the name of AppTek nor the names of its contributors may be used to endorse 
// 	or promote products derived from this software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
// THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
// OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// 

#region

using System;

#endregion

namespace Zen.Toolkit
{
    public abstract class ZenException : Exception
    {
        protected ZenException()
        {
        }

        protected ZenException(string message) : base(message)
        {
        }

        protected ZenException(string message, params object[] args) : base(string.Format(message, args))
        {
        }

        protected ZenException(Exception innerException, string message) : base(message, innerException)
        {
        }

        protected ZenException(Exception innerException, string message, params object[] args)
            : base(string.Format(message, args), innerException)
        {
        }
    }

    public class ZenManagerNotFoundException : ZenException
    {
        public ZenManagerNotFoundException()
        {
        }

        public ZenManagerNotFoundException(string message) : base(message)
        {
        }
    }

    public class ZenScriptException : ZenException
    {
        public ZenScriptException()
        {
        }

        public ZenScriptException(string message) : base(message)
        {
        }
    }

    public class ZenHandlerNotFoundException : ZenException
    {
        public ZenHandlerNotFoundException()
        {
        }

        public ZenHandlerNotFoundException(string message) : base(message)
        {
        }
    }

    public class ZenConfigurationException : ZenException
    {
        public ZenConfigurationException()
        {
        }

        public ZenConfigurationException(string message) : base(message)
        {
        }
    }

    public class ZenControlNotFoundException : ZenException
    {
        public ZenControlNotFoundException()
        {
        }

        public ZenControlNotFoundException(string message) : base(message)
        {
        }
    }

    public class ZenWidgetException : ZenException
    {
        public ZenWidgetException()
        {
        }

        public ZenWidgetException(string message) : base(message)
        {
        }

        public ZenWidgetException(string message, params object[] args) : base(string.Format(message, args))
        {
        }
    }
}