﻿// 
// $Id: HorizontalRule.cs 3981 2010-11-02 11:12:16Z unknown $
// 
// Zen UI Toolkit Copyright (c) 2010, Paul Clancy.  All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification, are permitted provided 
// that the following conditions are met:
// 
// * 	Redistributions of source code must retain the above copyright notice, this list of 
// 	conditions and the following disclaimer.
// 
// * 	Redistributions in binary form must reproduce the above copyright notice, this list of 
// 	conditions and the following disclaimer in the documentation and/or other materials 
// 	provided with the distribution.
// 
// * 	Neither the name of AppTek nor the names of its contributors may be used to endorse 
// 	or promote products derived from this software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
// THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
// OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// 

#region

using System.Collections.Generic;
using System.ComponentModel;
using System.Web.UI;

#endregion

namespace Zen.Toolkit
{
    [ToolboxData("<{0}:HorizontalRule runat=\"server\"></{0}:HorizontalRule>")]
    [ParseChildren(true)]
    [PersistChildren(false)]
    [DojoWidget(ClassMapping = "dijit.form.HorizontalRule", InvokeStartup = true)]
    [DojoRequires(ModuleName = "dijit.form.HorizontalRule")]
    [DojoRequires(ModuleName = "dijit.form.HorizontalRuleLabels")]
    public class HorizontalRule : FormWidget
    {
        private List<HorizontalRuleLabels> _labels;

        public HorizontalRule() : base(HtmlTextWriterTag.Div)
        {
        }

        [DojoProperty(Name = "count")]
        [Description("")]
        [DefaultValue(3)]
        public int TickCount
        {
            get
            {
                object o = ViewState["TickCount"];
                return (o == null) ? 3 : (int) o;
            }
            set { ViewState["TickCount"] = value; }
        }

        [NotifyParentProperty(true)]
        [DefaultValue(null)]
        [PersistenceMode(PersistenceMode.InnerProperty)]
        public List<HorizontalRuleLabels> Labels
        {
            get
            {
                if (_labels == null)
                    _labels = new List<HorizontalRuleLabels>();

                return _labels;
            }
        }

        protected override void CreateChildControls()
        {
            if (_labels != null)
            {
                //foreach (HorizontalRuleLabels label in _labels)
                //{
                //    label.Container = this;
                //    this.Page.Controls.Add(label);
                //}
                //string labelID = string.Format("_labels_{0}", this.ClientID);

                //StringBuilder listBuilder = new StringBuilder();
                //listBuilder.AppendFormat("<ol id=\"{0}\">", labelID);

                //foreach (HorizontalRuleLabel s in this.Labels)
                //{
                //    listBuilder.AppendFormat("<li>{0}</li>", s.Title);
                //}

                //listBuilder.Append("</ol>");

                //this.Controls.Add(new LiteralControl(listBuilder.ToString()));
            }

            base.CreateChildControls();
        }
    }
}