﻿// 
// $Id: Panel.cs 3981 2010-11-02 11:12:16Z unknown $
// 
// Zen UI Toolkit Copyright (c) 2010, Paul Clancy.  All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification, are permitted provided 
// that the following conditions are met:
// 
// * 	Redistributions of source code must retain the above copyright notice, this list of 
// 	conditions and the following disclaimer.
// 
// * 	Redistributions in binary form must reproduce the above copyright notice, this list of 
// 	conditions and the following disclaimer in the documentation and/or other materials 
// 	provided with the distribution.
// 
// * 	Neither the name of AppTek nor the names of its contributors may be used to endorse 
// 	or promote products derived from this software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
// THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
// OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// 

#region

using System;
using System.ComponentModel;
using System.Drawing;
using System.Web.UI;

#endregion

namespace Zen.Toolkit
{
    [ToolboxData("<{0}:Panel runat=\"server\"></{0}:Panel>")]
    [ToolboxBitmap(typeof (Panel), "Resources.Icons.Toolbox.picture_empty.bmp")]
    [ParseChildren(false)]
    [PersistChildren(true)]
    [DojoWidget(ClassMapping = "dijit.layout.ContentPane", InvokeStartup = true)]
    [DojoRequires(ModuleName = "dijit.layout.ContentPane")]
    public class Panel : ContainerWidget
    {
        public Panel() : base(HtmlTextWriterTag.Div)
        {
        }

        public Panel(WidgetBase container, Enums.LayoutRegion region) : base(HtmlTextWriterTag.Div)
        {
            Container = container;
            Region = region;
        }

        internal WidgetBase Container { get; set; }

        [DojoProperty(Name = "content")]
        [DefaultValue("")]
        public string HtmlContent
        {
            get { return (string) ViewState["HtmlContent"] ?? ""; }
            set { ViewState["HtmlContent"] = value; }
        }

        protected override void OnPreRender(EventArgs e)
        {
            if (Container != null)
            {
                ZenManager.Script.AddAfterWidgetInit(
                    this, "awi",
                    "{0}.addChild({1});",
                    Container.DojoID,
                    DojoID);
            }

            base.OnPreRender(e);
        }
    }
}